> ## Documentation Index
> Fetch the complete documentation index at: https://docs.axiom.xyz/llms.txt
> Use this file to discover all available pages before exploring further.

# Get proving keys

> Generate a presigned URL to download various proving keys for a configuration.

    Available key types:
    - `app`: Application VM proving key
    - `agg`: Aggregation proving key
    - `halo2`: Halo2 proving key



## OpenAPI

````yaml GET /v1/configs/{config_id}/pk/{key_type}
openapi: 3.1.0
info:
  title: Axiom Proving API
  description: |-
    ## Axiom Cloud Proving API

        The Axiom Proving API allows you to compile, execute, and prove OpenVM programs on Axiom's cloud infrastructure.

        All endpoints require an API key passed in the `Axiom-API-Key` header.
        
  version: 1.0.0
servers:
  - url: https://api.axiom.xyz
    description: Production API
  - url: https://api.staging.app.axiom.xyz
    description: Staging API
security: []
paths:
  /v1/configs/{config_id}/pk/{key_type}:
    get:
      tags:
        - configs
      summary: Download Proving Key
      description: >-
        Generate a presigned URL to download various proving keys for a
        configuration.

            Available key types:
            - `app`: Application VM proving key
            - `agg`: Aggregation proving key
            - `halo2`: Halo2 proving key
      operationId: download_proving_key_v1_configs__config_id__pk__key_type__get
      parameters:
        - name: config_id
          in: path
          required: true
          schema:
            type: string
            title: Config Id
        - name: key_type
          in: path
          required: true
          schema:
            type: string
            description: >-
              The type of proving key to download. Different keys are used for
              different parts of the proving system. Must be one of: app, agg,
              halo2
            title: Key Type
          description: >-
            The type of proving key to download. Different keys are used for
            different parts of the proving system. Must be one of: app, agg,
            halo2
        - name: openvm_full_version
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: >-
              Optional OpenVM full version with patch. If not provided, the
              latest for this config will be used.
            title: Openvm Full Version
          description: >-
            Optional OpenVM full version with patch. If not provided, the latest
            for this config will be used.
      responses:
        '200':
          description: Download URL generated successfully
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UrlDownloadResponse'
        '400':
          description: Invalid key type
        '404':
          description: Configuration or key not found
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyHeader: []
components:
  schemas:
    UrlDownloadResponse:
      properties:
        download_url:
          type: string
          title: Download Url
      type: object
      required:
        - download_url
      title: UrlDownloadResponse
      description: Response for download URL generation.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    APIKeyHeader:
      type: apiKey
      in: header
      name: Axiom-API-Key

````